(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var Random = Package.random.Random;
var _ = Package.underscore._;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPermissions, path;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-permissions":{"permissions.js":["babel-runtime/helpers/classCallCheck",function(require){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-permissions/permissions.js                                                                      //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                               //
                                                                                                                      //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                      //
                                                                                                                      //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                     //
                                                                                                                      //
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
var Crypto = Npm.require("crypto");                                                                                   // 17
                                                                                                                      //
SandstormPermissions = {};                                                                                            // 19
                                                                                                                      //
var PermissionSet = function () {                                                                                     //
  // A wrapper around an array of booleans representing a set of permissions like "read" or                           //
  // "write". This might represent the permissions held by some user on some grain, or it might                       //
  // represent the permissions that one user has chosen to share with another user.                                   //
  //                                                                                                                  //
  // In our model, permissions are independent. You can have "read" without "write" and you can                       //
  // have "write" without "read". Many apps don't actually allow arbitrary permutations, and                          //
  // instead define "roles" like "editor" or "viewer", where "editor" implies both read and write                     //
  // permission while "viewer" implies only read. Roles, however, are just aliases for sets of                        //
  // permissions; all actual computation is done on permissions.                                                      //
                                                                                                                      //
  function PermissionSet(array) {                                                                                     // 32
    (0, _classCallCheck3["default"])(this, PermissionSet);                                                            // 32
                                                                                                                      //
    if (!array) {                                                                                                     // 33
      this.array = [];                                                                                                // 34
    } else if (array instanceof Array) {                                                                              // 35
      this.array = array.slice(0);                                                                                    // 36
    } else {                                                                                                          // 37
      throw new Error("don't know how to interpret as PermissionSet: " + array);                                      // 38
    }                                                                                                                 // 39
  }                                                                                                                   // 40
                                                                                                                      //
  PermissionSet.fromRoleAssignment = function fromRoleAssignment(roleAssignment, viewInfo) {                          //
    // Create a PermissionSet based on a ViewSharingLink.RoleAssignment and a UiView.ViewInfo (as                     //
    // defined in grain.capnp). ViewInfo defines a mapping from roles to permission sets for a                        //
    // particular grain type. RoleAssignment represents the permissions passed from one user to                       //
    // another -- usually it specifies a single role, but sometimes also specifies permissions to                     //
    // add or remove as well.                                                                                         //
    //                                                                                                                //
    // A falsy value for `roleAssignment` is considered equivalent to a "none" value, which means                     //
    // that no role was explicitly chosen, so the default role should be assigned.                                    //
                                                                                                                      //
    var result = new PermissionSet([]);                                                                               // 52
                                                                                                                      //
    if (!roleAssignment || "none" in roleAssignment) {                                                                // 54
      // No role explicitly chosen, e.g. because the app did not define any roles at the time                         //
      // the sharing took place. Assign the default role, if there is one.                                            //
                                                                                                                      //
      if (viewInfo.roles) {                                                                                           // 58
        for (var ii = 0; ii < viewInfo.roles.length; ++ii) {                                                          // 59
          var roleDef = viewInfo.roles[ii];                                                                           // 60
          if (roleDef["default"]) {                                                                                   // 61
            result = new PermissionSet(roleDef.permissions);                                                          // 62
            break;                                                                                                    // 63
          }                                                                                                           // 64
        }                                                                                                             // 65
      }                                                                                                               // 66
    } else if ("allAccess" in roleAssignment) {                                                                       // 67
      // All permissions are shared, even if there is no explicitly-defined role for this.                            //
                                                                                                                      //
      var length = 0;                                                                                                 // 70
      if (viewInfo.permissions) {                                                                                     // 71
        length = viewInfo.permissions.length;                                                                         // 72
      }                                                                                                               // 73
                                                                                                                      //
      var array = new Array(length);                                                                                  // 75
      for (var _ii = 0; _ii < array.length; ++_ii) {                                                                  // 76
        array[_ii] = true;                                                                                            // 77
      }                                                                                                               // 78
                                                                                                                      //
      result = new PermissionSet(array);                                                                              // 80
    } else if ("roleId" in roleAssignment && viewInfo.roles && viewInfo.roles.length > 0) {                           // 81
      // A specific role was chosen.                                                                                  //
                                                                                                                      //
      var _roleDef = viewInfo.roles[roleAssignment.roleId];                                                           // 84
      if (_roleDef) {                                                                                                 // 85
        result = new PermissionSet(_roleDef.permissions);                                                             // 86
      }                                                                                                               // 87
    }                                                                                                                 // 88
                                                                                                                      //
    if (roleAssignment) {                                                                                             // 90
      // Add or remove specific permissions. This is uncommon.                                                        //
      result.add(new PermissionSet(roleAssignment.addPermissionSet));                                                 // 92
      result.remove(new PermissionSet(roleAssignment.removePermissionSet));                                           // 93
    }                                                                                                                 // 94
                                                                                                                      //
    return result;                                                                                                    // 96
  };                                                                                                                  // 97
                                                                                                                      //
  PermissionSet.prototype.isEmpty = function isEmpty() {                                                              //
    var result = true;                                                                                                // 100
    this.array.forEach(function (p) {                                                                                 // 101
      if (p) {                                                                                                        // 102
        result = false;                                                                                               // 103
      }                                                                                                               // 104
    });                                                                                                               // 105
                                                                                                                      //
    return result;                                                                                                    // 107
  };                                                                                                                  // 108
                                                                                                                      //
  PermissionSet.prototype.isSubsetOf = function isSubsetOf(other) {                                                   //
    check(other, PermissionSet);                                                                                      // 111
    for (var ii = 0; ii < this.array.length; ++ii) {                                                                  // 112
      var mine = this.array[ii];                                                                                      // 113
      var yours = other.array[ii] || false;                                                                           // 114
      if (mine && !yours) {                                                                                           // 115
        return false;                                                                                                 // 116
      }                                                                                                               // 117
    }                                                                                                                 // 118
                                                                                                                      //
    return true;                                                                                                      // 120
  };                                                                                                                  // 121
                                                                                                                      //
  // Methods for mutating a PermissionSet by combining it with another PermissionSet.                                 //
  // These return a boolean indicating whether the operation had any effect.                                          //
                                                                                                                      //
  PermissionSet.prototype.add = function add(other) {                                                                 //
    check(other, PermissionSet);                                                                                      // 127
    var changed = false;                                                                                              // 128
    for (var ii = 0; ii < other.array.length; ++ii) {                                                                 // 129
      var old = !!this.array[ii];                                                                                     // 130
      this.array[ii] = !!this.array[ii] || other.array[ii];                                                           // 131
      if (old !== this.array[ii]) {                                                                                   // 132
        changed = true;                                                                                               // 133
      }                                                                                                               // 134
    }                                                                                                                 // 135
                                                                                                                      //
    return changed;                                                                                                   // 137
  };                                                                                                                  // 138
                                                                                                                      //
  PermissionSet.prototype.remove = function remove(other) {                                                           //
    check(other, PermissionSet);                                                                                      // 141
    var changed = false;                                                                                              // 142
    for (var ii = 0; ii < other.array.length && ii < this.array.length; ++ii) {                                       // 143
      var old = !!this.array[ii];                                                                                     // 144
      this.array[ii] = !!this.array[ii] && !other.array[ii];                                                          // 145
      if (old !== this.array[ii]) {                                                                                   // 146
        changed = true;                                                                                               // 147
      }                                                                                                               // 148
    }                                                                                                                 // 149
                                                                                                                      //
    return changed;                                                                                                   // 151
  };                                                                                                                  // 152
                                                                                                                      //
  PermissionSet.prototype.intersect = function intersect(other) {                                                     //
    check(other, PermissionSet);                                                                                      // 155
    var changed = false;                                                                                              // 156
    for (var ii = 0; ii < this.array.length; ++ii) {                                                                  // 157
      var old = !!this.array[ii];                                                                                     // 158
      this.array[ii] = !!this.array[ii] && other.array[ii];                                                           // 159
      if (old !== this.array[ii]) {                                                                                   // 160
        changed = true;                                                                                               // 161
      }                                                                                                               // 162
    }                                                                                                                 // 163
                                                                                                                      //
    return changed;                                                                                                   // 165
  };                                                                                                                  // 166
                                                                                                                      //
  return PermissionSet;                                                                                               //
}();                                                                                                                  //
                                                                                                                      //
var RequirementSet = function () {                                                                                    //
  // A conjunction of permissions for identities on grains.                                                           //
  //                                                                                                                  //
  // This typically represents a set of `MembraneRequirement`s, as defined in `supervisor.capnp`.                     //
  // These represent conditions under which some connection formed between grains remains valid.                      //
  // When a capability travels from grain to grain, it passes across these connections -- if any                      //
  // of the connections becomes invalid (is revoked), then the capability must be revoked as well.                    //
  // The word "membrane" comes from the concept of revokable membranes; the capability is passing                     //
  // across such membranes as it travels.                                                                             //
  //                                                                                                                  //
  // For example, a RequirementSet might represent the statement "Alice has read access to Foo, Bob                   //
  // has write access to Foo, and Bob has read access to Bar". Specifically, this example situation                   //
  // would come about if:                                                                                             //
  // - Bob used his read access to Bar to extract a capability from it.                                               //
  // - Bob embedded that capability into Foo, using his write access.                                                 //
  // - Alice extracted the capability from Foo, using her read access.                                                //
  // If any of these permissions are revoked, then the capability needs to be revoked as well.                        //
                                                                                                                      //
  function RequirementSet() {                                                                                         // 187
    (0, _classCallCheck3["default"])(this, RequirementSet);                                                           // 187
                                                                                                                      //
    this.permissionsHeldRequirements = {};                                                                            // 188
    // Two-level map. Maps a pair of a grain ID and an identity ID to a PermissionSet.                                //
                                                                                                                      //
    this.userIsAdminRequirements = {};                                                                                // 191
    // Map from account ID to boolean. Represents a set of `userIsAdmin` requirements.                                //
                                                                                                                      //
    this.tokenValidRequirements = {};                                                                                 // 194
    // Map from token ID to boolean. Represents a set of `tokenValid` requirements.                                   //
  }                                                                                                                   // 196
                                                                                                                      //
  RequirementSet.prototype.isEmpty = function isEmpty() {                                                             //
    for (var tokenId in this.tokenValidRequirements) {                                                                // 199
      return false;                                                                                                   // 200
    }                                                                                                                 // 201
                                                                                                                      //
    for (var grainId in this.permissionsHeldRequirements) {                                                           // 203
      if (Object.keys(this.permissionsHeldRequirements[grainId]).length > 0) {                                        // 204
        return false;                                                                                                 // 205
      }                                                                                                               // 206
    }                                                                                                                 // 207
                                                                                                                      //
    return true;                                                                                                      // 209
  };                                                                                                                  // 210
                                                                                                                      //
  RequirementSet.prototype.addRequirements = function addRequirements(requirements) {                                 //
    var _this = this;                                                                                                 // 212
                                                                                                                      //
    // Updates this RequirementSet to include the permissions required by `requirements`, which                       //
    // is a decoded Cap'n Proto List(MembraneRequirement).                                                            //
                                                                                                                      //
    if (!requirements) return;                                                                                        // 216
    requirements.forEach(function (requirement) {                                                                     // 217
      if (requirement.permissionsHeld) {                                                                              // 218
        var grainId = requirement.permissionsHeld.grainId;                                                            // 219
        var identityId = requirement.permissionsHeld.identityId;                                                      // 220
        var permissions = new PermissionSet(requirement.permissionsHeld.permissions);                                 // 221
        _this._ensureEntryExists(grainId, identityId);                                                                // 222
        _this.permissionsHeldRequirements[grainId][identityId].add(permissions);                                      // 223
      } else if (requirement.userIsAdmin) {                                                                           // 224
        _this.userIsAdminRequirements[requirement.userIsAdmin] = true;                                                // 225
      } else if (requirement.tokenValid) {                                                                            // 226
        _this.tokenValidRequirements[requirement.tokenValid] = true;                                                  // 227
      } else {                                                                                                        // 228
        throw new Error("unsupported requirement: " + JSON.toString(requirement));                                    // 229
      }                                                                                                               // 230
    });                                                                                                               // 231
  };                                                                                                                  // 232
                                                                                                                      //
  RequirementSet.prototype._ensureEntryExists = function _ensureEntryExists(grainId, identityId) {                    //
    check(grainId, String);                                                                                           // 235
    check(identityId, String);                                                                                        // 236
                                                                                                                      //
    if (!this.permissionsHeldRequirements[grainId]) {                                                                 // 238
      this.permissionsHeldRequirements[grainId] = {};                                                                 // 239
    }                                                                                                                 // 240
                                                                                                                      //
    if (!this.permissionsHeldRequirements[grainId][identityId]) {                                                     // 242
      this.permissionsHeldRequirements[grainId][identityId] = new PermissionSet([]);                                  // 243
    }                                                                                                                 // 244
  };                                                                                                                  // 245
                                                                                                                      //
  RequirementSet.prototype.getGrainIds = function getGrainIds() {                                                     //
    return Object.keys(this.permissionsHeldRequirements);                                                             // 248
  };                                                                                                                  // 249
                                                                                                                      //
  RequirementSet.prototype.getTokenIds = function getTokenIds() {                                                     //
    return Object.keys(this.tokenValidRequirements);                                                                  // 252
  };                                                                                                                  // 253
                                                                                                                      //
  RequirementSet.prototype.forEach = function forEach(func) {                                                         //
    for (var tokenId in this.tokenValidRequirements) {                                                                // 256
      func({ tokenValid: tokenId });                                                                                  // 257
    }                                                                                                                 // 258
                                                                                                                      //
    for (var accountId in this.userIsAdminRequirements) {                                                             // 260
      func({ userIsAdmin: accountId });                                                                               // 261
    }                                                                                                                 // 262
                                                                                                                      //
    for (var grainId in this.permissionsHeldRequirements) {                                                           // 264
      for (var identityId in this.permissionsHeldRequirements[grainId]) {                                             // 265
        var permissions = this.permissionsHeldRequirements[grainId][identityId];                                      // 266
        func({                                                                                                        // 267
          permissionsHeld: {                                                                                          // 268
            grainId: grainId,                                                                                         // 269
            identityId: identityId,                                                                                   // 270
            permissionSet: permissions                                                                                // 271
          }                                                                                                           // 268
        });                                                                                                           // 267
      }                                                                                                               // 274
    }                                                                                                                 // 275
  };                                                                                                                  // 276
                                                                                                                      //
  return RequirementSet;                                                                                              //
}();                                                                                                                  //
                                                                                                                      //
// A permission ID is either the string "canAccess", corresponding to the implicit "can access                        //
// the grain at all" permission, or a non-negative integer, corresponding to a permission                             //
// defined by the app in its manifest.                                                                                //
                                                                                                                      //
                                                                                                                      //
var PermissionId = Match.OneOf("canAccess", Match.Integer);                                                           // 282
                                                                                                                      //
function forEachPermission(permissions, func) {                                                                       // 284
  // Calls `func` on "canAccess" and each permission ID that corresponds to a `true`                                  //
  // value in `permissions`.                                                                                          //
  check(permissions, [Boolean]);                                                                                      // 287
  func("canAccess");                                                                                                  // 288
  for (var ii = 0; ii < permissions.length; ++ii) {                                                                   // 289
    if (permissions[ii]) {                                                                                            // 290
      func(ii);                                                                                                       // 291
    }                                                                                                                 // 292
  }                                                                                                                   // 293
}                                                                                                                     // 294
                                                                                                                      //
// A vertex is a principal in the sharing graph. A "vertex ID" is either "i:" + an identity ID,                       //
// or "t:" + a token ID. In some limited contexts, "o:Owner" is also allowed, signifying the                          //
// *account* of the grain owner, from which all permissions flow.                                                     //
                                                                                                                      //
function vertexIdOfTokenOwner(token) {                                                                                // 300
  // Returns which vertex recieves permissions from this token.                                                       //
                                                                                                                      //
  var result = "t:" + token._id; // the bearer of the token                                                           // 303
  if (token.owner && token.owner.user) {                                                                              // 304
    result = "i:" + token.owner.user.identityId; // the identity that owns the token                                  // 305
  }                                                                                                                   // 306
                                                                                                                      //
  return result;                                                                                                      // 308
}                                                                                                                     // 309
                                                                                                                      //
var Variable =                                                                                                        //
// Our permissions computation can be framed as a propositional HORNSAT problem; this `Variable`                      //
// class represents a variable in that sense. There is a variable for every (grain ID, vertex ID,                     //
// permission ID) triple. There is also a variable for every non-UiView ApiToken, to account for                      //
// `tokenValid` requirements. In any given computation, we only explicitly construct those                            //
// variables that we know might actually be relevant to the result.                                                   //
//                                                                                                                    //
// The value of a variable represents an answer to the question "does this vertex in the sharing                      //
// graph receive this permission at this grain?" We start out by setting all variables to `false`,                    //
// and we only set a variable to `true` when an edge in the sharing graph forces us to. If                            //
// this forward-chaining eventually forces us to set our end goal variables to `true`, then the                       //
// HORNSAT problem is unsatisfiable and we have proved what we wanted. Otherwise, the HORNSAT                         //
// problem is satisfiable, i.e. there is a consistent way to set values to variables in which                         //
// our goal nodes do *not* receive the permissions we wanted them to receive.                                         //
                                                                                                                      //
function Variable() {                                                                                                 // 326
  (0, _classCallCheck3["default"])(this, Variable);                                                                   // 326
                                                                                                                      //
  this.value = false;                                                                                                 // 327
                                                                                                                      //
  this.directDependents = [];                                                                                         // 329
  // List of token IDs for outgoing edges that need to be looked at once this variable gets set                       //
  // to `true`.                                                                                                       //
                                                                                                                      //
  this.requirementDependents = [];                                                                                    // 333
  // List of token IDs for tokens that have requirements that get fulfilled once this variable                        //
  // gets set to `true`.                                                                                              //
};                                                                                                                    // 336
                                                                                                                      //
var ActiveToken = function () {                                                                                       //
  // An "active token" is one that we allow to propagate permissions because we've decided                            //
  // that it might be relevant to our current computation. This class tracks which permissions                        //
  // the token can carry, which of those permissions we've actually proved to arrive at the source                    //
  // end of the token, and how many of the token's requirements are still unmet.                                      //
                                                                                                                      //
  function ActiveToken(tokenId, requirements, numUnmetRequirements, permissions, grainId, recipientId) {              // 345
    (0, _classCallCheck3["default"])(this, ActiveToken);                                                              // 345
                                                                                                                      //
    check(tokenId, String);                                                                                           // 346
    check(numUnmetRequirements, Match.Integer);                                                                       // 347
    check(grainId, String);                                                                                           // 348
    check(recipientId, String);                                                                                       // 349
                                                                                                                      //
    check(permissions, [Boolean]);                                                                                    // 351
    // The permissions that this token is capable of carrying, in addition to the implicit                            //
    // "canAccess" permission.                                                                                        //
                                                                                                                      //
    this.tokenId = tokenId;                                                                                           // 355
    this.requirements = requirements;                                                                                 // 356
    this.grainId = grainId;                                                                                           // 357
    this.recipientId = recipientId;                                                                                   // 358
                                                                                                                      //
    this.numUnmetRequirements = numUnmetRequirements;                                                                 // 360
    // How many of this token's requirements we have not yet proven to be met.                                        //
                                                                                                                      //
    this.receivedPermissions = new Array();                                                                           // 363
    // A map from permission ID to boolean. If a permission ID is present in this map,                                //
    // then this token's roleAssignment includes that permission. If the corresponding                                //
    // value is `true`, then we've proven that this token receives this permission and                                //
    // therefore propagates it if the requirements are met.                                                           //
                                                                                                                      //
    this.receivedPermissions.canAccess = false;                                                                       // 369
    for (var ii = 0; ii < permissions.length; ++ii) {                                                                 // 370
      if (permissions[ii]) {                                                                                          // 371
        this.receivedPermissions[ii] = false;                                                                         // 372
      }                                                                                                               // 373
    }                                                                                                                 // 374
  }                                                                                                                   // 375
                                                                                                                      //
  ActiveToken.prototype.requirementsAreMet = function requirementsAreMet() {                                          //
    // Have we yet proved that all of this token's requirements are met?                                              //
    return this.numUnmetRequirements == 0;                                                                            // 379
  };                                                                                                                  // 380
                                                                                                                      //
  ActiveToken.prototype.decrementRequirements = function decrementRequirements(context) {                             //
    var _this2 = this;                                                                                                // 382
                                                                                                                      //
    // Decrements the number of unmet requirements of this token.                                                     //
    check(context, Context);                                                                                          // 384
    this.numUnmetRequirements -= 1;                                                                                   // 385
    if (this.numUnmetRequirements < 0) {                                                                              // 386
      throw new Meteor.Error(500, "numUnmetRequirements is negative");                                                // 387
    }                                                                                                                 // 388
                                                                                                                      //
    if (this.requirementsAreMet()) {                                                                                  // 390
      // This was the last missing requirement for this token, therefore we've triggered the                          //
      // outgoing edges from the token corresponding to each known incoming permission.                               //
      this.forEachReceivedPermission(function (permissionId) {                                                        // 393
        // We've triggered a new edge! Push it onto the queue.                                                        //
        context.setToTrueStack.push({ grainId: _this2.grainId,                                                        // 395
          vertexId: _this2.recipientId,                                                                               // 396
          permissionId: permissionId,                                                                                 // 397
          responsibleTokenId: _this2.tokenId });                                                                      // 398
      });                                                                                                             // 399
    }                                                                                                                 // 400
  };                                                                                                                  // 401
                                                                                                                      //
  ActiveToken.prototype.setReceivesPermission = function setReceivesPermission(permissionId, context) {               //
    // Records that this token receives a permission.                                                                 //
    check(permissionId, PermissionId);                                                                                // 405
    check(context, Context);                                                                                          // 406
    if (permissionId in this.receivedPermissions) {                                                                   // 407
      this.receivedPermissions[permissionId] = true;                                                                  // 408
    }                                                                                                                 // 409
                                                                                                                      //
    if (this.numUnmetRequirements == 0) {                                                                             // 411
      context.setToTrueStack.push({ grainId: this.grainId,                                                            // 412
        vertexId: this.recipientId,                                                                                   // 413
        permissionId: permissionId,                                                                                   // 414
        responsibleTokenId: this.tokenId });                                                                          // 415
    } else {                                                                                                          // 416
      // Since we know permissions flow to this token, and the token is active (meaning it                            //
      // may be relevant to the overall computation), we now know that it's worth checking                            //
      // the token's requirements. Add them to `unmetRequirements`. Note that these requirement                       //
      // could actually be ones that we've checked already, but we'll figure that out once                            //
      // processUnmetRequirements() runs and discovers it isn't activating any new tokens.                            //
      //                                                                                                              //
      // TODO(perf): This is an overestimate. It might be worthwhile to keep track of which                           //
      //   requirements are already met, so that we don't need to add them here.                                      //
                                                                                                                      //
      context.unmetRequirements.addRequirements(this.requirements);                                                   // 426
    }                                                                                                                 // 427
  };                                                                                                                  // 428
                                                                                                                      //
  ActiveToken.prototype.forEachReceivedPermission = function forEachReceivedPermission(func) {                        //
    // Calls `func` on each permission ID that we've proven this token receives.                                      //
                                                                                                                      //
    if (this.receivedPermissions.canAccess) {                                                                         // 433
      func("canAccess");                                                                                              // 434
    }                                                                                                                 // 435
                                                                                                                      //
    // Note: Array.forEach() does hit the "canAccess" permission ID.                                                  //
    this.receivedPermissions.forEach(function (received, permissionId) {                                              // 438
      if (received) {                                                                                                 // 439
        func(permissionId);                                                                                           // 440
      }                                                                                                               // 441
    });                                                                                                               // 442
  };                                                                                                                  // 443
                                                                                                                      //
  return ActiveToken;                                                                                                 //
}();                                                                                                                  //
                                                                                                                      //
var Context = function () {                                                                                           //
  // An ongoing permissions computation, including cached database state.                                             //
                                                                                                                      //
  function Context() {                                                                                                // 449
    (0, _classCallCheck3["default"])(this, Context);                                                                  // 449
                                                                                                                      //
    this.grains = {}; // Map from grain ID to entry in Grains table.                                                  // 450
    this.userIdentityIds = {}; // Map from account ID to list of linked identity IDs.                                 // 451
    this.adminUsers = {}; // Set of account IDs for admins.                                                           // 452
    this.tokensById = {}; // Map from token ID to token.                                                              // 453
    this.tokensByRecipient = {}; // Map from grain ID and identity ID to token array.                                 // 454
                                                                                                                      //
    this.variables = {};                                                                                              // 456
    // GrainId -> VertexId -> PermissionId -> Variable                                                                //
    //                                                                                                                //
    // We have a special fake grain ID "tokenValid", where we store the variables that track                          //
    // `tokenValid` requirements. Only the "canAccess" permission makes sense for that fake grain.                    //
                                                                                                                      //
    this.userIsAdminVariables = {};                                                                                   // 462
    // Account ID -> Variable                                                                                         //
                                                                                                                      //
    this.activeTokens = {}; // TokenId -> ActiveToken                                                                 // 465
                                                                                                                      //
    this.setToTrueStack = [];                                                                                         // 467
    // Variables enqueued to be set to true.                                                                          //
    // Array of { grainId: String, vertexId: String, permissionId: PermissionId,                                      //
    //            responsibleTokenId: Optional(String) }                                                              //
                                                                                                                      //
    this.unmetRequirements = new RequirementSet();                                                                    // 472
    // As we run our forward-chaining algorithm, when we encounter a token with unmet requirements                    //
    // we add those requirements to this set. Then, if we find that our current knowledge base                        //
    // is not large enough to prove our goal, we can expand our search by following these                             //
    // requirements backwards and activating tokens that might help prove that they are met.                          //
    // `unmetRequirements` is allowed to be an overestimate -- in fact, when adding requirements                      //
    // to `unmetRequirements` we generally do not check if they had already been proven. The next                     //
    // run of processUnmetRequirements(), however, will find that all of the tokens activated by                      //
    // the requirements were already active.                                                                          //
  }                                                                                                                   // 481
                                                                                                                      //
  Context.prototype.reset = function reset() {                                                                        //
    // Resets all state except this.grains, this.userIdentityIds, and this.adminUsers.                                //
    this.tokensById = {};                                                                                             // 485
    this.tokensByRecipient = {};                                                                                      // 486
    this.unmetRequirements = new RequirementSet();                                                                    // 487
    this.setToTrueStack = [];                                                                                         // 488
    this.variables = {};                                                                                              // 489
    this.activeTokens = {};                                                                                           // 490
  };                                                                                                                  // 491
                                                                                                                      //
  Context.prototype.addToken = function addToken(token) {                                                             //
    // Adds a token to `this.tokensById`. If the token is a UiView, also adds it to                                   //
    // `this.tokensByRecipient`. Does not activate the token.                                                         //
                                                                                                                      //
    var isUiView = token.grainId && !token.objectId;                                                                  // 497
                                                                                                                      //
    if (this.tokensById[token._id]) return;                                                                           // 499
                                                                                                                      //
    this.tokensById[token._id] = token;                                                                               // 501
    if (isUiView && token.owner && token.owner.user) {                                                                // 502
      if (!this.tokensByRecipient[token.grainId]) {                                                                   // 503
        this.tokensByRecipient[token.grainId] = {};                                                                   // 504
      }                                                                                                               // 505
                                                                                                                      //
      if (!this.tokensByRecipient[token.grainId][token.owner.user.identityId]) {                                      // 507
        this.tokensByRecipient[token.grainId][token.owner.user.identityId] = [];                                      // 508
      }                                                                                                               // 509
                                                                                                                      //
      this.tokensByRecipient[token.grainId][token.owner.user.identityId].push(token);                                 // 511
    }                                                                                                                 // 512
  };                                                                                                                  // 513
                                                                                                                      //
  Context.prototype.addGrains = function addGrains(db, grainIds) {                                                    //
    var _this3 = this;                                                                                                // 515
                                                                                                                      //
    // Retrieves grains from the database.                                                                            //
                                                                                                                      //
    check(db, SandstormDb);                                                                                           // 518
    check(grainIds, [String]);                                                                                        // 519
    if (grainIds.length == 0) return; // Nothing to do.                                                               // 520
                                                                                                                      //
    db.collections.grains.find({ _id: { $in: grainIds }, trashed: { $exists: false } }).forEach(function (grain) {    // 522
      _this3.grains[grain._id] = grain;                                                                               // 523
      if (!_this3.userIdentityIds[grain.userId]) {                                                                    // 524
        _this3.userIdentityIds[grain.userId] = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));
      }                                                                                                               // 527
    });                                                                                                               // 528
                                                                                                                      //
    var query = { grainId: { $in: grainIds },                                                                         // 530
      revoked: { $ne: true },                                                                                         // 531
      trashed: { $exists: false },                                                                                    // 532
      objectId: { $exists: false } };                                                                                 // 533
    db.collections.apiTokens.find(query).forEach(function (token) {                                                   // 534
      return _this3.addToken(token);                                                                                  // 534
    });                                                                                                               // 534
  };                                                                                                                  // 535
                                                                                                                      //
  Context.prototype.addTokensFromCursor = function addTokensFromCursor(cursor) {                                      //
    var _this4 = this;                                                                                                // 537
                                                                                                                      //
    cursor.forEach(function (token) {                                                                                 // 538
      return _this4.addToken(token);                                                                                  // 538
    });                                                                                                               // 538
  };                                                                                                                  // 539
                                                                                                                      //
  Context.prototype.activateOwnerEdges = function activateOwnerEdges(grainId, edges) {                                //
    var _this5 = this;                                                                                                // 541
                                                                                                                      //
    check(edges, [{ identityId: String, role: SandstormDb.prototype.roleAssignmentPattern }]);                        // 542
                                                                                                                      //
    edges.forEach(function (edge) {                                                                                   // 544
      var viewInfo = _this5.grains[grainId].cachedViewInfo || {};                                                     // 545
      var permissions = PermissionSet.fromRoleAssignment(edge.role, viewInfo);                                        // 546
      var vertexId = "i:" + edge.identityId;                                                                          // 547
      forEachPermission(permissions.array, function (permissionId) {                                                  // 548
        _this5.setToTrueStack.push({                                                                                  // 549
          grainId: grainId,                                                                                           // 550
          vertexId: vertexId,                                                                                         // 551
          permissionId: permissionId                                                                                  // 552
        });                                                                                                           // 549
      });                                                                                                             // 554
    });                                                                                                               // 555
                                                                                                                      //
    return edges.length > 0;                                                                                          // 557
  };                                                                                                                  // 558
                                                                                                                      //
  Context.prototype.registerInterestInRequirements = function registerInterestInRequirements(tokenId, requirements) {
    var _this6 = this;                                                                                                // 560
                                                                                                                      //
    // Add all requirements.                                                                                          //
    var numUnmetRequirements = 0;                                                                                     // 562
    if (requirements) {                                                                                               // 563
      requirements.forEach(function (requirement) {                                                                   // 564
        if (requirement.permissionsHeld) {                                                                            // 565
          (function () {                                                                                              // 565
            var reqGrainId = requirement.permissionsHeld.grainId;                                                     // 566
            var reqVertexId = "i:" + requirement.permissionsHeld.identityId;                                          // 567
            var reqPermissions = requirement.permissionsHeld.permissions || [];                                       // 568
                                                                                                                      //
            forEachPermission(reqPermissions, function (permissionId) {                                               // 570
              var variable = _this6.getVariable(reqGrainId, reqVertexId, permissionId);                               // 571
              if (!variable.value) {                                                                                  // 572
                // This requirement hasn't been proven yet. We add it to the variable's list of                       //
                // dependents so that we get notified when that variable is proven, and we increment                  //
                // numUnmetRequirements to indicate how many notifications we need to get before we                   //
                // know all requirements are satisfied.                                                               //
                numUnmetRequirements += 1;                                                                            // 577
                variable.requirementDependents.push(tokenId);                                                         // 578
              }                                                                                                       // 579
            });                                                                                                       // 580
          })();                                                                                                       // 565
        } else if (requirement.userIsAdmin) {                                                                         // 581
          var accountId = requirement.userIsAdmin;                                                                    // 582
          var variable = _this6.getUserIsAdminVariable(accountId);                                                    // 583
          if (!variable.value) {                                                                                      // 584
            numUnmetRequirements += 1;                                                                                // 585
            variable.requirementDependents.push(tokenId);                                                             // 586
          }                                                                                                           // 587
        } else if (requirement.tokenValid) {                                                                          // 588
          var reqTokenId = requirement.tokenValid;                                                                    // 589
          var _variable = _this6.getVariable("tokenValid", "t:" + reqTokenId, "canAccess");                           // 590
          if (!_variable.value) {                                                                                     // 591
            numUnmetRequirements += 1;                                                                                // 592
            _variable.requirementDependents.push(tokenId);                                                            // 593
          }                                                                                                           // 594
        } else {                                                                                                      // 595
          throw new Error("unknown kind of requirement: " + JSON.stringify(requirement));                             // 596
        }                                                                                                             // 597
      });                                                                                                             // 598
    }                                                                                                                 // 599
                                                                                                                      //
    return numUnmetRequirements;                                                                                      // 601
  };                                                                                                                  // 602
                                                                                                                      //
  Context.prototype.activateToken = function activateToken(tokenId) {                                                 //
    var _this7 = this;                                                                                                // 604
                                                                                                                      //
    // Includes a new token (which must already be in `this.tokensById`) in our computation. The                      //
    // tricky part here is dealing with our already-accumulated knowledge; we need to compute how                     //
    // many of the token's requirements are currently unmet and whether we need to push anything new                  //
    // onto `setToTrueStack`.                                                                                         //
                                                                                                                      //
    check(tokenId, String);                                                                                           // 610
    if (tokenId in this.activeTokens) {                                                                               // 611
      return false;                                                                                                   // 612
    }                                                                                                                 // 613
                                                                                                                      //
    var token = this.tokensById[tokenId];                                                                             // 615
    var grainId = token.grainId;                                                                                      // 616
    var viewInfo = this.grains[grainId].cachedViewInfo || {};                                                         // 617
    var tokenPermissions = PermissionSet.fromRoleAssignment(token.roleAssignment, viewInfo);                          // 618
                                                                                                                      //
    var sharerId = token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId;                            // 620
    var recipientId = vertexIdOfTokenOwner(token);                                                                    // 621
                                                                                                                      //
    var numUnmetRequirements = this.registerInterestInRequirements(tokenId, token.requirements);                      // 623
    var activeToken = new ActiveToken(tokenId, token.requirements, numUnmetRequirements, tokenPermissions.array, grainId, recipientId);
                                                                                                                      //
    // Add all edges represented by this token (one for each permission).                                             //
    forEachPermission(tokenPermissions.array, function (permissionId) {                                               // 628
      var recipientVariable = _this7.getVariable(grainId, recipientId, permissionId);                                 // 629
      if (!recipientVariable.value) {                                                                                 // 630
        var sharerVariable = _this7.getVariable(grainId, sharerId, permissionId);                                     // 631
        if (!sharerVariable.value) {                                                                                  // 632
          // Not proven yet that the source has this permission, so add to its direct dependents so                   //
          // that we get notified if that changes.                                                                    //
          sharerVariable.directDependents.push(tokenId);                                                              // 635
        } else {                                                                                                      // 636
          // The source has already been proven.                                                                      //
          activeToken.setReceivesPermission(permissionId, _this7);                                                    // 638
        }                                                                                                             // 639
      }                                                                                                               // 640
    });                                                                                                               // 641
                                                                                                                      //
    this.activeTokens[tokenId] = activeToken;                                                                         // 643
                                                                                                                      //
    return true;                                                                                                      // 645
  };                                                                                                                  // 646
                                                                                                                      //
  Context.prototype.activateTokenValidToken = function activateTokenValidToken(tokenId) {                             //
    // Like `activateToken()`, but for a token that appears in a `tokenValid` requirement.                            //
    // Such tokens require some special handling to fit into our computation.                                         //
                                                                                                                      //
    check(tokenId, String);                                                                                           // 652
    if (tokenId in this.activeTokens) {                                                                               // 653
      return false;                                                                                                   // 654
    }                                                                                                                 // 655
                                                                                                                      //
    var token = this.tokensById[tokenId];                                                                             // 657
    if (!token) {                                                                                                     // 658
      return false;                                                                                                   // 659
    }                                                                                                                 // 660
                                                                                                                      //
    var numUnmetRequirements = this.registerInterestInRequirements(tokenId, token.requirements);                      // 662
    var activeToken = new ActiveToken(tokenId, token.requirements, numUnmetRequirements, [], "tokenValid", "t:" + tokenId);
                                                                                                                      //
    var recipientId = "t:" + tokenId;                                                                                 // 666
    var sharerVariable = token.parentToken && this.getVariable("tokenValid", "t:" + token.parentToken, "canAccess");  // 667
                                                                                                                      //
    var recipientVariable = this.getVariable("tokenValid", recipientId, "canAccess");                                 // 670
    if (!recipientVariable.value) {                                                                                   // 671
      if (!token.parentToken || sharerVariable && sharerVariable.value) {                                             // 672
        // The source has already been proven.                                                                        //
        activeToken.setReceivesPermission("canAccess", this);                                                         // 674
      } else {                                                                                                        // 675
        // Not proven yet that the source has this permission, so add to its direct dependents so                     //
        // that we get notified if that changes.                                                                      //
        sharerVariable.directDependents.push(tokenId);                                                                // 678
      }                                                                                                               // 679
    }                                                                                                                 // 680
                                                                                                                      //
    this.activeTokens[tokenId] = activeToken;                                                                         // 682
                                                                                                                      //
    return true;                                                                                                      // 684
  };                                                                                                                  // 685
                                                                                                                      //
  Context.prototype.getVariable = function getVariable(grainId, vertexId, permissionId) {                             //
    check(grainId, String);                                                                                           // 688
    check(vertexId, String);                                                                                          // 689
    check(permissionId, PermissionId);                                                                                // 690
                                                                                                                      //
    if (!this.variables[grainId]) {                                                                                   // 692
      this.variables[grainId] = {};                                                                                   // 693
    }                                                                                                                 // 694
                                                                                                                      //
    if (!this.variables[grainId][vertexId]) {                                                                         // 696
      this.variables[grainId][vertexId] = new Array();                                                                // 697
    }                                                                                                                 // 698
                                                                                                                      //
    if (!this.variables[grainId][vertexId][permissionId]) {                                                           // 700
      this.variables[grainId][vertexId][permissionId] = new Variable();                                               // 701
    }                                                                                                                 // 702
                                                                                                                      //
    return this.variables[grainId][vertexId][permissionId];                                                           // 704
  };                                                                                                                  // 705
                                                                                                                      //
  Context.prototype.getUserIsAdminVariable = function getUserIsAdminVariable(accountId) {                             //
    check(accountId, String);                                                                                         // 708
                                                                                                                      //
    if (!this.userIsAdminVariables[accountId]) {                                                                      // 710
      this.userIsAdminVariables[accountId] = new Variable();                                                          // 711
    }                                                                                                                 // 712
                                                                                                                      //
    return this.userIsAdminVariables[accountId];                                                                      // 714
  };                                                                                                                  // 715
                                                                                                                      //
  Context.prototype.getPermissions = function getPermissions(grainId, vertexId) {                                     //
    // Looks up the permissions that have already been proven for the `vertexId` on `grainId`.                        //
                                                                                                                      //
    check(grainId, String);                                                                                           // 720
    check(vertexId, String);                                                                                          // 721
                                                                                                                      //
    if (!this.getVariable(grainId, vertexId, "canAccess").value) {                                                    // 723
      return null;                                                                                                    // 724
    } else {                                                                                                          // 725
      var length = this.variables[grainId][vertexId].length;                                                          // 726
      var permissions = new Array(length);                                                                            // 727
      for (var idx = 0; idx < length; ++idx) {                                                                        // 728
        if (this.variables[grainId][vertexId][idx]) {                                                                 // 729
          permissions[idx] = !!this.variables[grainId][vertexId][idx].value;                                          // 730
        } else {                                                                                                      // 731
          permissions[idx] = false;                                                                                   // 732
        }                                                                                                             // 733
      }                                                                                                               // 734
                                                                                                                      //
      return new PermissionSet(permissions);                                                                          // 736
    }                                                                                                                 // 737
  };                                                                                                                  // 738
                                                                                                                      //
  Context.prototype.runForwardChaining = function runForwardChaining(grainId, vertexId, permissionSet) {              //
    var _this8 = this;                                                                                                // 740
                                                                                                                      //
    // Runs forward-chaining, consuming elements from `this.setToTrueStack` and propagating                           //
    // their permissions, until we've proven that `(grainId, vertexId)` has the permissions in                        //
    // `permissionSet`, or until we've exhausted `this.setToTrueStack`.                                               //
    //                                                                                                                //
    // TODO(perf): Exit early if we've already proven that permissionSet is fulfilled.                                //
                                                                                                                      //
    check(grainId, String);                                                                                           // 747
    check(vertexId, String);                                                                                          // 748
    check(permissionSet, PermissionSet);                                                                              // 749
                                                                                                                      //
    if (permissionSet.array.length > 0) {                                                                             // 751
      // Make sure that the result of this call, retrieved through `this.getPermissions()`,                           //
      // will have a full array of permissions, even if they won't all be set to `true`.                              //
      this.getVariable(grainId, vertexId, permissionSet.array.length - 1);                                            // 754
    }                                                                                                                 // 755
                                                                                                                      //
    var _loop = function _loop() {                                                                                    // 740
      var current = _this8.setToTrueStack.pop();                                                                      // 758
      var variable = _this8.getVariable(current.grainId, current.vertexId, current.permissionId);                     // 759
      if (variable.value) {                                                                                           // 760
        return "continue";                                                                                            // 761
      }                                                                                                               // 762
                                                                                                                      //
      // For the first time, this vertex is now known to be satisfied.                                                //
      variable.value = true;                                                                                          // 765
                                                                                                                      //
      // For each edge (token) whose source is this vertex, mark that the input permission is                         //
      // fulfilled.                                                                                                   //
      variable.responsibleTokenId = current.responsibleTokenId;                                                       // 769
      variable.directDependents.forEach(function (tokenId) {                                                          // 770
        // We know this permission must be met now. We also know that the permission was not met                      //
        // for this token previously becaues a token has exactly one source vertex for each                           //
        // permission, and we're processing that vertex now.                                                          //
                                                                                                                      //
        _this8.activeTokens[tokenId].setReceivesPermission(current.permissionId, _this8);                             // 775
      });                                                                                                             // 776
                                                                                                                      //
      // For each token that has a requirement on this vertex, mark that one of its requirements                      //
      // has ben fulfilled.                                                                                           //
      variable.requirementDependents.forEach(function (tokenId) {                                                     // 780
        _this8.activeTokens[tokenId].decrementRequirements(_this8);                                                   // 781
      });                                                                                                             // 782
    };                                                                                                                // 740
                                                                                                                      //
    while (this.setToTrueStack.length > 0) {                                                                          // 757
      var _ret2 = _loop();                                                                                            // 757
                                                                                                                      //
      if (_ret2 === "continue") continue;                                                                             // 757
    }                                                                                                                 // 783
                                                                                                                      //
    return this.getPermissions(grainId, vertexId);                                                                    // 785
  };                                                                                                                  // 786
                                                                                                                      //
  Context.prototype.activateRelevantTokens = function activateRelevantTokens(grainId, vertexId) {                     //
    var _this9 = this;                                                                                                // 788
                                                                                                                      //
    // Returns true if more computation might yield more progress.                                                    //
                                                                                                                      //
    check(grainId, String);                                                                                           // 791
    check(vertexId, String);                                                                                          // 792
                                                                                                                      //
    var result = false;                                                                                               // 794
    var relevant = computeRelevantTokens(this, grainId, vertexId);                                                    // 795
    if (this.activateOwnerEdges(grainId, relevant.ownerEdges)) {                                                      // 796
      result = true;                                                                                                  // 797
    }                                                                                                                 // 798
                                                                                                                      //
    relevant.tokenIds.forEach(function (tokenId) {                                                                    // 800
      if (_this9.activateToken(tokenId)) {                                                                            // 801
        result = true;                                                                                                // 802
      }                                                                                                               // 803
    });                                                                                                               // 804
                                                                                                                      //
    return result;                                                                                                    // 806
  };                                                                                                                  // 807
                                                                                                                      //
  Context.prototype.processUnmetRequirements = function processUnmetRequirements(db) {                                //
    var _this10 = this;                                                                                               // 809
                                                                                                                      //
    // Activate all tokens relevant to the requirements in `unmetRequirements`. May do a database                     //
    // query to look up new tokens.                                                                                   //
    //                                                                                                                //
    // Returns true if more computation might yield more progress, i.e., at least one token was                       //
    // newly-activated.                                                                                               //
                                                                                                                      //
    var grainIds = this.unmetRequirements.getGrainIds().filter(function (grainId) {                                   // 816
      return !(grainId in _this10.grains);                                                                            // 817
    });                                                                                                               // 817
                                                                                                                      //
    if (db) {                                                                                                         // 819
      this.addGrains(db, grainIds);                                                                                   // 820
    }                                                                                                                 // 821
                                                                                                                      //
    var result = false;                                                                                               // 823
                                                                                                                      //
    // As we process our requirements, we might find new unmet requirments.                                           //
    // We defer processing those until the next time around.                                                          //
    var oldUnmetRequirements = this.unmetRequirements;                                                                // 827
    this.unmetRequirements = new RequirementSet();                                                                    // 828
                                                                                                                      //
    oldUnmetRequirements.forEach(function (req) {                                                                     // 830
      if (req.permissionsHeld) {                                                                                      // 831
        var next = req.permissionsHeld;                                                                               // 832
        // Activate all tokens relevant to this requirement.                                                          //
        // TODO(perf): We're actually overestimating, because we're activating tokens relevant to                     //
        //   *all* permissions rather than just the permissions specified by the requirement. E.g.                    //
        //   if the requirement is that Bob has write access, then tokens which only transmit read                    //
        //   access are not relevant, but we'll end up activating them anyway.                                        //
        if (_this10.activateRelevantTokens(next.grainId, "i:" + next.identityId)) {                                   // 838
          result = true;                                                                                              // 839
        }                                                                                                             // 840
      } else if (req.tokenValid) {                                                                                    // 841
        // Active the token and all of its transitive parents.                                                        //
        var currentTokenId = req.tokenValid;                                                                          // 843
        while (true) {                                                                                                // 844
          var currentToken = _this10.tokensById[currentTokenId];                                                      // 845
          if (!currentToken && db) {                                                                                  // 846
            currentToken = db.collections.apiTokens.findOne({                                                         // 847
              _id: currentTokenId,                                                                                    // 848
              revoked: { $ne: true }                                                                                  // 849
            });                                                                                                       // 847
            _this10.tokensById[currentTokenId] = currentToken;                                                        // 851
          }                                                                                                           // 852
                                                                                                                      //
          if (!currentToken) {                                                                                        // 854
            break;                                                                                                    // 855
          }                                                                                                           // 856
                                                                                                                      //
          if (_this10.activateTokenValidToken(currentTokenId)) {                                                      // 858
            result = true;                                                                                            // 859
          }                                                                                                           // 860
                                                                                                                      //
          if (currentToken.parentToken) {                                                                             // 862
            currentTokenId = currentToken.parentToken;                                                                // 863
          } else {                                                                                                    // 864
            break;                                                                                                    // 865
          }                                                                                                           // 866
        }                                                                                                             // 867
      } else if (req.userIsAdmin) {                                                                                   // 868
        var accountId = req.userIsAdmin;                                                                              // 869
        if (!(accountId in _this10.adminUsers) && db) {                                                               // 870
          Meteor.users.find({ isAdmin: true }).forEach(function (user) {                                              // 871
            _this10.adminUsers[user._id] = true;                                                                      // 872
          });                                                                                                         // 873
        }                                                                                                             // 874
                                                                                                                      //
        if (_this10.adminUsers[accountId]) {                                                                          // 876
          var variable = _this10.getUserIsAdminVariable(accountId);                                                   // 877
          variable.value = true;                                                                                      // 878
                                                                                                                      //
          // Might have some requirement dependents. Cannot have any direct depependents.                             //
          variable.requirementDependents.forEach(function (tokenId) {                                                 // 881
            result = true;                                                                                            // 882
            _this10.activeTokens[tokenId].decrementRequirements(_this10);                                             // 883
          });                                                                                                         // 884
        }                                                                                                             // 885
      } else {                                                                                                        // 886
        throw new Error("unknown kind of requirement: " + JSON.stringify(req));                                       // 887
      }                                                                                                               // 888
    });                                                                                                               // 889
                                                                                                                      //
    return result;                                                                                                    // 891
  };                                                                                                                  // 892
                                                                                                                      //
  Context.prototype.tryToProve = function tryToProve(grainId, vertexId, permissionSet, db) {                          //
    // Tries to prove that `vertexId` has the given permissions on the given grain. Returns a                         //
    // `PermissionSet` representing the permissions proven, or null if it has not been proved                         //
    // yet that the vertex even has access to the grain.                                                              //
                                                                                                                      //
    check(grainId, String);                                                                                           // 899
    check(vertexId, String);                                                                                          // 900
    check(permissionSet, PermissionSet);                                                                              // 901
    check(db, Match.OneOf(undefined, SandstormDb));                                                                   // 902
    // If `db` is not provided, then this function will make no database queries.                                     //
                                                                                                                      //
    if (db) {                                                                                                         // 905
      this.addGrains(db, [grainId]);                                                                                  // 906
    }                                                                                                                 // 907
                                                                                                                      //
    this.activateRelevantTokens(grainId, vertexId);                                                                   // 909
    while (true) {                                                                                                    // 910
      var result = this.runForwardChaining(grainId, vertexId, permissionSet);                                         // 911
      if (result && permissionSet.isSubsetOf(result)) {                                                               // 912
        return result;                                                                                                // 913
      }                                                                                                               // 914
                                                                                                                      //
      if (!this.processUnmetRequirements(db)) {                                                                       // 916
        return result;                                                                                                // 917
      }                                                                                                               // 918
    }                                                                                                                 // 919
  };                                                                                                                  // 920
                                                                                                                      //
  Context.prototype.getResponsibleTokens = function getResponsibleTokens(grainId, vertexId) {                         //
    // For the permissions that we've already proven must be held by `vertexId`, transitively finds                   //
    // the tokens that we have used in that proof, including tokens responsible for fulfilling                        //
    // membrane requirements.                                                                                         //
    //                                                                                                                //
    // Whenever we prove a fact, we keep track of the immediately responsible token for that fact,                    //
    // This function works by walking backwards in the sharing graph, following this trail of                         //
    // "responsible tokens".                                                                                          //
    //                                                                                                                //
    // Returns an object with two fields:                                                                             //
    //    tokenIds: list of IDs of the responsible tokens.                                                            //
    //    grainIds: list of IDs of all relevant grains.                                                               //
                                                                                                                      //
    check(grainId, String);                                                                                           // 935
    check(vertexId, String);                                                                                          // 936
                                                                                                                      //
    var stack = []; // [{ grainId: String, vertexId: String, permissionId: PermissionId }]                            // 938
    var visited = new Array(); // grainId -> vertexId -> permissionId -> bool;                                        // 939
                                                                                                                      //
    function pushVertex(grainId, vertexId, permissionId) {                                                            // 941
      if (!visited[grainId]) {                                                                                        // 942
        visited[grainId] = {};                                                                                        // 943
      }                                                                                                               // 944
                                                                                                                      //
      if (!visited[grainId][vertexId]) {                                                                              // 946
        visited[grainId][vertexId] = {};                                                                              // 947
      }                                                                                                               // 948
                                                                                                                      //
      var vertex = visited[grainId][vertexId];                                                                        // 950
      if (!vertex[permissionId]) {                                                                                    // 951
        vertex[permissionId] = true;                                                                                  // 952
        stack.push({ grainId: grainId, vertexId: vertexId, permissionId: permissionId });                             // 953
      }                                                                                                               // 954
    }                                                                                                                 // 955
                                                                                                                      //
    var neededTokens = {}; // TokenId -> bool                                                                         // 957
                                                                                                                      //
    forEachPermission(this.getPermissions(grainId, vertexId).array, function (permissionId) {                         // 959
      pushVertex(grainId, vertexId, permissionId);                                                                    // 960
    });                                                                                                               // 961
                                                                                                                      //
    while (stack.length > 0) {                                                                                        // 963
      var _current = stack.pop();                                                                                     // 964
      var variable = this.getVariable(_current.grainId, _current.vertexId, _current.permissionId);                    // 965
      var tokenId = variable.responsibleTokenId;                                                                      // 966
      if (tokenId) {                                                                                                  // 967
        var token = this.tokensById[tokenId];                                                                         // 968
                                                                                                                      //
        if (token.grainId && !token.objectId) {                                                                       // 970
          var sharerId = token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId;                      // 971
          pushVertex(token.grainId, sharerId, _current.permissionId);                                                 // 972
        } else if (token.parentToken) {                                                                               // 973
          pushVertex("tokenValid", "t:" + token.parentToken, "canAccess");                                            // 974
        }                                                                                                             // 975
                                                                                                                      //
        if (!neededTokens[tokenId]) {                                                                                 // 977
          neededTokens[tokenId] = true;                                                                               // 978
          if (token.requirements) {                                                                                   // 979
            token.requirements.forEach(function (requirement) {                                                       // 980
              if (requirement.permissionsHeld) {                                                                      // 981
                (function () {                                                                                        // 981
                  var reqVertexId = "i:" + requirement.permissionsHeld.identityId;                                    // 982
                  forEachPermission(requirement.permissionsHeld.permissions, function (permissionId) {                // 983
                    pushVertex(requirement.permissionsHeld.grainId, reqVertexId, permissionId);                       // 984
                  });                                                                                                 // 985
                })();                                                                                                 // 981
              } else if (requirement.tokenValid) {                                                                    // 986
                pushVertex("tokenValid", "t:" + requirement.tokenValid, "canAccess");                                 // 987
              }                                                                                                       // 988
            });                                                                                                       // 989
          }                                                                                                           // 990
        }                                                                                                             // 991
      }                                                                                                               // 992
    }                                                                                                                 // 993
                                                                                                                      //
    return { tokenIds: Object.keys(neededTokens), grainIds: Object.keys(visited) };                                   // 995
  };                                                                                                                  // 996
                                                                                                                      //
  return Context;                                                                                                     //
}();                                                                                                                  //
                                                                                                                      //
function computeRelevantTokens(context, grainId, vertexId) {                                                          // 999
  // Finds all tokens in `context` that could possibly carry permissions of the grain `grainId` to                    //
  // the vertex `vertexId` -- that is, all tokens that are contained in a path starting at the                        //
  // grain owner and ending at `vertexId`. Ignores any requirements that those tokens might be                        //
  // conditional upon.                                                                                                //
  //                                                                                                                  //
  // Returns an object with two fields:                                                                               //
  //    tokenIds: list of relevant token IDs.                                                                         //
  //    ownerEdges: objects of the form { identityId: String, role: RoleAssignment }, representing                    //
  //                initial pseudo-edges in the graph. `identityId` is typically an identity of                       //
  //                the grain's owning user, but for the case of a legacy public grain it could                       //
  //                be any identity.                                                                                  //
  //                                                                                                                  //
  // Works by traversing the sharing graph twice: first backwards starting from `vertexId`, then                      //
  // forwards starting from the grain owner using only those tokens touched in the first step.                        //
  //                                                                                                                  //
  // `context` contains all the information from the database which is available for now. This call                   //
  // will not make any new database lookups; edges not listed in `context` will not be considered                     //
  // (as if they'd been revoked).                                                                                     //
                                                                                                                      //
  check(context, Context);                                                                                            // 1019
  check(grainId, String);                                                                                             // 1020
  check(vertexId, String);                                                                                            // 1021
                                                                                                                      //
  var grain = context.grains[grainId];                                                                                // 1023
  if (!grain) return { tokenIds: [], ownerEdges: [] };                                                                // 1024
  var viewInfo = grain.cachedViewInfo || {};                                                                          // 1025
  var ownerIdentityIds = context.userIdentityIds[grain.userId];                                                       // 1026
                                                                                                                      //
  var vertexStack = []; // Vertex IDs that we need to explore.                                                        // 1028
  var visitedVertexIds = {}; // Set of vertex IDs that we have already enqueued to get explored.                      // 1029
                                                                                                                      //
  visitedVertexIds[vertexId] = true;                                                                                  // 1031
  vertexStack.push(vertexId);                                                                                         // 1032
                                                                                                                      //
  var visitedTokensBySharerId = {};                                                                                   // 1034
  var ownerEdges = [];                                                                                                // 1035
                                                                                                                      //
  // Repeatedly pop a vertex from the stack, find all its incoming edges (i.e. all other vertexes                     //
  // that share permissions to this vertex), and push those vertexes onto the stack.                                  //
                                                                                                                      //
  var _loop2 = function _loop2() {                                                                                    // 999
    var vertexId = vertexStack.pop();                                                                                 // 1040
                                                                                                                      //
    var incomingEdges = [];                                                                                           // 1042
    // List of edges in the sharing graph ending at this vertex. Each is an object with the fields:                   //
    //     sharerId: The vertex ID of the edge's source.                                                              //
    //     token: the token object backing this edge, if there is one.                                                //
                                                                                                                      //
    function tokenToEdge(token) {                                                                                     // 1047
      // Convert an ApiToken into an edge.                                                                            //
      return {                                                                                                        // 1049
        token: token,                                                                                                 // 1050
        sharerId: token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId                              // 1051
      };                                                                                                              // 1049
    }                                                                                                                 // 1053
                                                                                                                      //
    if (vertexId.slice(0, 2) === "o:") {                                                                              // 1055
      // Owner. We don't need to do anything.                                                                         //
      incomingEdges = [];                                                                                             // 1057
    } else if (vertexId.slice(0, 2) === "t:") {                                                                       // 1058
      // A webkey token. Extract it from the context (or ignore if it isn't present).                                 //
      var _token = context.tokensById[vertexId.slice(2)];                                                             // 1060
      if (_token) {                                                                                                   // 1061
        incomingEdges = [tokenToEdge(_token)];                                                                        // 1062
      }                                                                                                               // 1063
    } else if (vertexId.slice(0, 2) === "i:") {                                                                       // 1064
      // An identity.                                                                                                 //
      var identityId = vertexId.slice(2);                                                                             // 1066
      if (ownerIdentityIds.indexOf(identityId) >= 0) {                                                                // 1067
        // This is one of the owner's identities.                                                                     //
        incomingEdges = [{ sharerId: "o:Owner" }];                                                                    // 1069
        ownerEdges.push({ identityId: identityId, role: { allAccess: null } });                                       // 1070
      } else if (!grain["private"]) {                                                                                 // 1071
        // This is a legacy "public" grain, meaning that any user who knows the grain ID receives                     //
        // the grain's default role. If the user doesn't know the grain ID then they are unable                       //
        // to express a request to open the grain in the first place and we'll never get to the                       //
        // point of this permissions computation, so for this purpose we can assume all users                         //
        // have the default role. (Similarly, a user who doesn't know the grain ID couldn't                           //
        // possibly be the subject of any MembraneRequirements against the grain because they                         //
        // have never interacted with the grain and so couldn't have caused such                                      //
        // MembraneRequiments to come about. Note that this is kind of shaky non-local reasoning,                     //
        // but literally no such legacy grain has been created since early 2015 and none will ever                    //
        // be created again, so it's not a huge deal.)                                                                //
        incomingEdges = [{ sharerId: "o:Owner" }];                                                                    // 1082
        ownerEdges.push({ identityId: identityId, role: { none: null } });                                            // 1083
      } else {                                                                                                        // 1084
        // Not a special case. Gather all tokens where this user is the recipient.                                    //
        incomingEdges = ((context.tokensByRecipient[grainId] || {})[vertexId.slice(2)] || []).map(tokenToEdge);       // 1086
      }                                                                                                               // 1088
    } else {                                                                                                          // 1089
      throw new Meteor.Error(500, "Unrecognized vertex ID: " + vertexId);                                             // 1090
    }                                                                                                                 // 1091
                                                                                                                      //
    // For each edge incoming to this vertex, backpropagate this vertex's PermissionFlow to the                       //
    // source vertex, joining it with the edge's constraints.                                                         //
    incomingEdges.forEach(function (edge) {                                                                           // 1095
      var sharerId = edge.sharerId;                                                                                   // 1096
      if (edge.token) {                                                                                               // 1097
        if (!visitedTokensBySharerId[sharerId]) {                                                                     // 1098
          visitedTokensBySharerId[sharerId] = {};                                                                     // 1099
        }                                                                                                             // 1100
                                                                                                                      //
        visitedTokensBySharerId[sharerId][edge.token._id] = edge.token;                                               // 1102
      }                                                                                                               // 1103
                                                                                                                      //
      if (!visitedVertexIds[sharerId]) {                                                                              // 1105
        // Never saw this vertex before.                                                                              //
        visitedVertexIds[sharerId] = true;                                                                            // 1107
        vertexStack.push(sharerId);                                                                                   // 1108
      }                                                                                                               // 1109
    });                                                                                                               // 1111
  };                                                                                                                  // 999
                                                                                                                      //
  while (vertexStack.length > 0) {                                                                                    // 1039
    _loop2();                                                                                                         // 1039
  }                                                                                                                   // 1112
                                                                                                                      //
  // Now walk forward from the owner.                                                                                 //
  var relevantTokens = {};                                                                                            // 1115
  var visitedSharers = {};                                                                                            // 1116
                                                                                                                      //
  var sharerStack = [];                                                                                               // 1118
  ownerIdentityIds.forEach(function (identityId) {                                                                    // 1119
    sharerStack.push("i:" + identityId);                                                                              // 1119
  });                                                                                                                 // 1119
  while (sharerStack.length > 0) {                                                                                    // 1120
    var sharerId = sharerStack.pop();                                                                                 // 1121
    for (var tokenId in visitedTokensBySharerId[sharerId]) {                                                          // 1122
      relevantTokens[tokenId] = true;                                                                                 // 1123
      var token = visitedTokensBySharerId[sharerId][tokenId];                                                         // 1124
      var recipientId = vertexIdOfTokenOwner(token);                                                                  // 1125
                                                                                                                      //
      if (!visitedSharers[recipientId]) {                                                                             // 1127
        visitedSharers[recipientId] = true;                                                                           // 1128
        sharerStack.push(recipientId);                                                                                // 1129
      }                                                                                                               // 1130
    }                                                                                                                 // 1131
  }                                                                                                                   // 1132
                                                                                                                      //
  return {                                                                                                            // 1134
    tokenIds: Object.keys(relevantTokens),                                                                            // 1135
    ownerEdges: ownerEdges                                                                                            // 1136
  };                                                                                                                  // 1134
}                                                                                                                     // 1138
                                                                                                                      //
var vertexPattern = Match.OneOf({ token: Match.ObjectIncluding({ _id: String, grainId: String }) }, {                 // 1140
  grain: Match.ObjectIncluding({                                                                                      // 1143
    _id: String,                                                                                                      // 1144
    identityId: Match.OneOf(String, null, undefined)                                                                  // 1145
  })                                                                                                                  // 1143
});                                                                                                                   // 1142
// A vertex in the sharing graph is a principal, e.g. a user (identity) or a token. Complicating                      //
// matters, we may have to traverse sharing graphs for multiple grains in the same computation. A                     //
// token is specific to one grain, but a user of course can have access to multiple grains, so in                     //
// the case of a user we represent the vertex as a (user, grain) pair.                                                //
//                                                                                                                    //
// TODO(cleanup): Perhaps `grain` should be renamed to `user` or `identity`? In the common case                       //
//   where only a single grain's shares need to be considered, it feels weird to think of the                         //
//   grain ID as being the primary distinguishing feature of the vertex.                                              //
                                                                                                                      //
SandstormPermissions.mayOpenGrain = function (db, vertex) {                                                           // 1158
  // Determines whether the vertex is allowed to open the grain. May make multiple database                           //
  // queries.                                                                                                         //
                                                                                                                      //
  check(vertex, vertexPattern);                                                                                       // 1162
  var grainId = vertex.token ? vertex.token.grainId : vertex.grain._id;                                               // 1163
  var vertexId = vertex.token ? "t:" + vertex.token._id : "i:" + vertex.grain.identityId;                             // 1164
  var context = new Context();                                                                                        // 1165
  var emptyPermissions = new PermissionSet([]);                                                                       // 1166
  return !!context.tryToProve(grainId, vertexId, emptyPermissions, db);                                               // 1167
};                                                                                                                    // 1168
                                                                                                                      //
var CompoundObserveHandle = function () {                                                                             //
  function CompoundObserveHandle() {                                                                                  // 1171
    (0, _classCallCheck3["default"])(this, CompoundObserveHandle);                                                    // 1171
                                                                                                                      //
    this._handles = [];                                                                                               // 1172
  }                                                                                                                   // 1173
                                                                                                                      //
  CompoundObserveHandle.prototype.push = function push(handle) {                                                      //
    this._handles.push(handle);                                                                                       // 1176
  };                                                                                                                  // 1177
                                                                                                                      //
  CompoundObserveHandle.prototype.stop = function stop() {                                                            //
    this._handles.forEach(function (handle) {                                                                         // 1180
      return handle.stop();                                                                                           // 1180
    });                                                                                                               // 1180
  };                                                                                                                  // 1181
                                                                                                                      //
  return CompoundObserveHandle;                                                                                       //
}();                                                                                                                  //
                                                                                                                      //
SandstormPermissions.grainPermissions = function (db, vertex, viewInfo, onInvalidated) {                              // 1184
  // Computes the set of permissions received by `vertex`. Returns an object with a                                   //
  // `permissions` field containing the computed permissions. If the field is null then                               //
  // the `vertex` does not even have the base "allowed to access at all" permission.                                  //
  //                                                                                                                  //
  // `onInvalidated` is an optional callback. If provided, it will be called when the result                          //
  // has been invalidated. If `onValidated` is provided, the result of `grainPermissions` will                        //
  // have a `observeHandle` field, containing an object with a `stop()` method that must be                           //
  // called once the computation becomes so longer relevant.                                                          //
                                                                                                                      //
  check(db, SandstormDb);                                                                                             // 1194
  check(vertex, vertexPattern);                                                                                       // 1195
  var grainId = vertex.token ? vertex.token.grainId : vertex.grain._id;                                               // 1196
  var vertexId = vertex.token ? "t:" + vertex.token._id : "i:" + vertex.grain.identityId;                             // 1197
                                                                                                                      //
  var resultPermissions = void 0;                                                                                     // 1199
  var observeHandle = void 0;                                                                                         // 1200
  var onInvalidatedActive = false;                                                                                    // 1201
                                                                                                                      //
  var startTime = new Date();                                                                                         // 1203
  function measureElapsedTime(result) {                                                                               // 1204
    var elapsedMilliseconds = new Date() - startTime;                                                                 // 1205
    if (elapsedMilliseconds > 200) {                                                                                  // 1206
      console.log("Warning: SandstormPermissions.grainPermissions() took " + elapsedMilliseconds + " milliseconds to complete for the vertex " + JSON.stringify(vertex));
    }                                                                                                                 // 1209
  }                                                                                                                   // 1210
                                                                                                                      //
  // Our computation proceeds in two phases. In the first, we determine which permissions the vertex                  //
  // appears to have and we compute set of tokens which appears to be sufficent to prove those                        //
  // permissions. However, concurrent database modifications may render the computation invalid, so                   //
  // in the second phases we verify that our proof is still valid and arrange for onInvalidated                       //
  // to be called when necessary. This is an optimisistic approach to concurrency. If the                             //
  // verification phase fails, we try again before giving up entirely.                                                //
                                                                                                                      //
  var _loop3 = function _loop3(attemptCount) {                                                                        // 1184
    if (observeHandle) {                                                                                              // 1219
      observeHandle.stop();                                                                                           // 1220
      observeHandle = null;                                                                                           // 1221
    }                                                                                                                 // 1222
                                                                                                                      //
    var context = new Context();                                                                                      // 1224
    var allPermissions = PermissionSet.fromRoleAssignment({ allAccess: null }, viewInfo);                             // 1225
    var firstPhasePermissions = context.tryToProve(grainId, vertexId, allPermissions, db);                            // 1226
                                                                                                                      //
    if (!firstPhasePermissions) return "break"; // No permissions; give up now.                                       // 1228
                                                                                                                      //
    var needed = context.getResponsibleTokens(grainId, vertexId);                                                     // 1230
    var neededTokens = needed.tokenIds;                                                                               // 1231
    var neededGrains = needed.grainIds;                                                                               // 1232
                                                                                                                      //
    // Phase 2: Now let's verify those permissions.                                                                   //
                                                                                                                      //
    context.reset();                                                                                                  // 1236
                                                                                                                      //
    var invalidated = false;                                                                                          // 1238
    function guardedOnInvalidated() {                                                                                 // 1239
      var shouldCall = onInvalidatedActive && !invalidated;                                                           // 1240
      invalidated = true;                                                                                             // 1241
      if (shouldCall) {                                                                                               // 1242
        onInvalidated();                                                                                              // 1243
      }                                                                                                               // 1244
    }                                                                                                                 // 1245
                                                                                                                      //
    var tokenCursor = db.collections.apiTokens.find({                                                                 // 1247
      _id: { $in: neededTokens },                                                                                     // 1248
      revoked: { $ne: true },                                                                                         // 1249
      objectId: { $exists: false }                                                                                    // 1250
    });                                                                                                               // 1247
                                                                                                                      //
    if (onInvalidated) {                                                                                              // 1253
      observeHandle = new CompoundObserveHandle();                                                                    // 1254
      observeHandle.push(tokenCursor.observe({                                                                        // 1255
        changed: function changed(newApiToken, oldApiToken) {                                                         // 1256
          if (newApiToken.trashed || !_.isEqual(newApiToken.roleAssignment, oldApiToken.roleAssignment) || !_.isEqual(newApiToken.revoked, oldApiToken.revoked)) {
            observeHandle.stop();                                                                                     // 1260
            guardedOnInvalidated();                                                                                   // 1261
          }                                                                                                           // 1262
        },                                                                                                            // 1263
        removed: function removed(oldApiToken) {                                                                      // 1265
          observeHandle.stop();                                                                                       // 1266
          guardedOnInvalidated();                                                                                     // 1267
        }                                                                                                             // 1268
      }));                                                                                                            // 1255
                                                                                                                      //
      var grainCursor = db.collections.grains.find({ _id: { $in: neededGrains } });                                   // 1271
      observeHandle.push(grainCursor.observe({                                                                        // 1272
        changed: function changed(newGrain, oldGrain) {                                                               // 1273
          if (newGrain.trashed || !oldGrain["private"] && newGrain["private"]) {                                      // 1274
            observeHandle.stop();                                                                                     // 1277
            guardedOnInvalidated();                                                                                   // 1278
          }                                                                                                           // 1279
        },                                                                                                            // 1280
        removed: function removed(oldGrain) {                                                                         // 1282
          observeHandle.stop();                                                                                       // 1283
          guardedOnInvalidated();                                                                                     // 1284
        }                                                                                                             // 1285
      }));                                                                                                            // 1272
    }                                                                                                                 // 1287
                                                                                                                      //
    context.addTokensFromCursor(tokenCursor);                                                                         // 1289
                                                                                                                      //
    // TODO(someday): Also account for linking/unlinking of identities and accounts losing admin                      //
    //   privileges. Currently we do not call `onInvalided()` on such events. We would need to set                    //
    //   up more cursor observers.                                                                                    //
                                                                                                                      //
    resultPermissions = context.tryToProve(grainId, vertexId, firstPhasePermissions);                                 // 1295
                                                                                                                      //
    if (resultPermissions && firstPhasePermissions.isSubsetOf(resultPermissions)) {                                   // 1297
      // We've confirmed the permissions that we found the in the first phase. Done!                                  //
      return "break";                                                                                                 // 1299
    }                                                                                                                 // 1300
  };                                                                                                                  // 1184
                                                                                                                      //
  for (var attemptCount = 0; attemptCount < 3; ++attemptCount) {                                                      // 1218
    var _ret5 = _loop3(attemptCount);                                                                                 // 1218
                                                                                                                      //
    if (_ret5 === "break") break;                                                                                     // 1218
  } // for (let attemptCount ...) {                                                                                   // 1301
                                                                                                                      //
  onInvalidatedActive = true;                                                                                         // 1303
  var result = {};                                                                                                    // 1304
  result.permissions = resultPermissions && resultPermissions.array || null;                                          // 1305
  result.observeHandle = observeHandle || new CompoundObserveHandle();                                                // 1306
  measureElapsedTime();                                                                                               // 1307
  return result;                                                                                                      // 1308
};                                                                                                                    // 1309
                                                                                                                      //
SandstormPermissions.downstreamTokens = function (db, root) {                                                         // 1311
  // Computes a list of the UiView tokens that are downstream in the sharing graph from a given                       //
  // source. The source, `root`, can either be a token or a (grain, user) pair. The exact format                      //
  // of `root` is specified in the `check()` invocation below.                                                        //
  //                                                                                                                  //
  // TODO(someday): Account for membrane requirements in this computation.                                            //
                                                                                                                      //
  check(root, Match.OneOf({ token: Match.ObjectIncluding({ _id: String, grainId: String }) }, { grain: Match.ObjectIncluding({ _id: String, identityId: String }) }));
                                                                                                                      //
  var result = [];                                                                                                    // 1321
  var tokenStack = [];                                                                                                // 1322
  var stackedTokens = {};                                                                                             // 1323
  var tokensBySharer = {};                                                                                            // 1324
  var tokensByParent = {};                                                                                            // 1325
  var tokensById = {};                                                                                                // 1326
                                                                                                                      //
  function addChildren(tokenId) {                                                                                     // 1328
    var children = tokensByParent[tokenId];                                                                           // 1329
    if (children) {                                                                                                   // 1330
      children.forEach(function (child) {                                                                             // 1331
        if (!stackedTokens[child._id]) {                                                                              // 1332
          tokenStack.push(child);                                                                                     // 1333
          stackedTokens[child._id] = true;                                                                            // 1334
        }                                                                                                             // 1335
      });                                                                                                             // 1336
    }                                                                                                                 // 1337
  }                                                                                                                   // 1338
                                                                                                                      //
  function addSharedTokens(sharer) {                                                                                  // 1340
    var sharedTokens = tokensBySharer[sharer];                                                                        // 1341
    if (sharedTokens) {                                                                                               // 1342
      sharedTokens.forEach(function (sharedToken) {                                                                   // 1343
        if (!stackedTokens[sharedToken._id]) {                                                                        // 1344
          tokenStack.push(sharedToken);                                                                               // 1345
          stackedTokens[sharedToken._id] = true;                                                                      // 1346
        }                                                                                                             // 1347
      });                                                                                                             // 1348
    }                                                                                                                 // 1349
  }                                                                                                                   // 1350
                                                                                                                      //
  var grainId = root.token ? root.token.grainId : root.grain._id;                                                     // 1352
  var grain = db.getGrain(grainId);                                                                                   // 1353
  if (!grain || !grain["private"]) {                                                                                  // 1354
    return result;                                                                                                    // 1354
  }                                                                                                                   // 1354
                                                                                                                      //
  db.collections.apiTokens.find({ grainId: grainId,                                                                   // 1356
    revoked: { $ne: true } }).forEach(function (token) {                                                              // 1357
    tokensById[token._id] = token;                                                                                    // 1358
    if (token.parentToken) {                                                                                          // 1359
      if (!tokensByParent[token.parentToken]) {                                                                       // 1360
        tokensByParent[token.parentToken] = [];                                                                       // 1361
      }                                                                                                               // 1362
                                                                                                                      //
      tokensByParent[token.parentToken].push(token);                                                                  // 1364
    } else if (token.identityId) {                                                                                    // 1365
      if (!tokensBySharer[token.identityId]) {                                                                        // 1366
        tokensBySharer[token.identityId] = [];                                                                        // 1367
      }                                                                                                               // 1368
                                                                                                                      //
      tokensBySharer[token.identityId].push(token);                                                                   // 1370
    }                                                                                                                 // 1371
  });                                                                                                                 // 1372
                                                                                                                      //
  if (root.token) {                                                                                                   // 1374
    addChildren(root.token._id);                                                                                      // 1375
  } else if (root.grain) {                                                                                            // 1376
    addSharedTokens(root.grain.identityId);                                                                           // 1377
  }                                                                                                                   // 1378
                                                                                                                      //
  while (tokenStack.length > 0) {                                                                                     // 1380
    var token = tokenStack.pop();                                                                                     // 1381
    result.push(token);                                                                                               // 1382
    addChildren(token._id);                                                                                           // 1383
    if (token.owner && token.owner.user) {                                                                            // 1384
      addSharedTokens(token.owner.user.identityId);                                                                   // 1385
    }                                                                                                                 // 1386
  }                                                                                                                   // 1387
                                                                                                                      //
  return result;                                                                                                      // 1389
};                                                                                                                    // 1390
                                                                                                                      //
var HeaderSafeString = Match.Where(function (str) {                                                                   // 1392
  check(str, String);                                                                                                 // 1393
  return str.match(/^[\x20-\x7E]*$/);                                                                                 // 1394
});                                                                                                                   // 1395
                                                                                                                      //
var DavClass = Match.Where(function (str) {                                                                           // 1397
  check(str, String);                                                                                                 // 1398
  return str.match(/^[a-zA-Z0-9!#$%&'*+.^_`|~-]+$/) || str.match(/^<[\x21-\x7E]*>$/); // supposed to be a URL         // 1399
});                                                                                                                   // 1401
                                                                                                                      //
var ResourceMap = Match.Where(function (map) {                                                                        // 1403
  for (path in map) {                                                                                                 // 1404
    if (!path.match(/^\/[\x21-\x7E]*$/)) {                                                                            // 1405
      return false;                                                                                                   // 1406
    }                                                                                                                 // 1407
                                                                                                                      //
    check(map[path], {                                                                                                // 1409
      type: HeaderSafeString,                                                                                         // 1410
      language: Match.Optional(HeaderSafeString),                                                                     // 1411
      encoding: Match.Optional(HeaderSafeString),                                                                     // 1412
      body: String                                                                                                    // 1413
    });                                                                                                               // 1409
  }                                                                                                                   // 1415
                                                                                                                      //
  return true;                                                                                                        // 1417
});                                                                                                                   // 1418
                                                                                                                      //
var LocalizedString = {                                                                                               // 1420
  defaultText: String,                                                                                                // 1421
  localizations: Match.Optional([{ locale: String, text: String }])                                                   // 1422
};                                                                                                                    // 1420
                                                                                                                      //
SandstormPermissions.createNewApiToken = function (db, provider, grainId, petname, roleAssignment, owner, unauthenticated) {
  // Creates a new UiView API token. If `rawParentToken` is set, creates a child token.                               //
  check(grainId, String);                                                                                             // 1430
  check(petname, String);                                                                                             // 1431
  check(roleAssignment, db.roleAssignmentPattern);                                                                    // 1432
  // Meteor bug #3877: we get null here instead of undefined when we                                                  //
  // explicitly pass in undefined.                                                                                    //
  check(provider, Match.OneOf({ identityId: String, accountId: String }, { rawParentToken: Match.OneOf(String, Buffer) }));
  check(owner, Match.OneOf({                                                                                          // 1437
    webkey: Match.OneOf(null, {                                                                                       // 1438
      forSharing: Boolean,                                                                                            // 1439
      expiresIfUnusedDuration: Match.Optional(Number)                                                                 // 1440
    })                                                                                                                // 1438
  }, {                                                                                                                // 1437
    user: {                                                                                                           // 1443
      identityId: String,                                                                                             // 1444
      title: String,                                                                                                  // 1445
      renamed: Match.Optional(Boolean),                                                                               // 1446
      upstreamTitle: Match.Optional(String),                                                                          // 1447
      seenAllActivity: Match.Optional(Boolean)                                                                        // 1448
    }                                                                                                                 // 1443
  }, {                                                                                                                // 1442
    grain: {                                                                                                          // 1451
      grainId: String,                                                                                                // 1452
      saveLabel: LocalizedString,                                                                                     // 1453
      introducerIdentity: String                                                                                      // 1454
    }                                                                                                                 // 1451
  }, {                                                                                                                // 1450
    clientPowerboxRequest: {                                                                                          // 1457
      grainId: String,                                                                                                // 1458
      sessionId: String,                                                                                              // 1459
      introducerIdentity: String                                                                                      // 1460
    }                                                                                                                 // 1457
  }, {                                                                                                                // 1456
    frontend: null                                                                                                    // 1463
  }));                                                                                                                // 1462
                                                                                                                      //
  check(unauthenticated, Match.OneOf(undefined, null, {                                                               // 1466
    options: Match.Optional({ dav: [Match.Optional(DavClass)] }),                                                     // 1467
    resources: Match.Optional(ResourceMap)                                                                            // 1468
  }));                                                                                                                // 1466
                                                                                                                      //
  if (unauthenticated && JSON.stringify(unauthenticated).length > 4096) {                                             // 1471
    throw new Meteor.Error(400, "Unauthenticated params too large; limit 4kb.");                                      // 1472
  }                                                                                                                   // 1473
                                                                                                                      //
  var grain = db.getGrain(grainId);                                                                                   // 1475
  if (!grain) {                                                                                                       // 1476
    throw new Meteor.Error(403, "Unauthorized", "No grain found.");                                                   // 1477
  }                                                                                                                   // 1478
                                                                                                                      //
  var token = Random.secret();                                                                                        // 1480
  var apiToken = {                                                                                                    // 1481
    _id: Crypto.createHash("sha256").update(token).digest("base64"),                                                  // 1482
    grainId: grainId,                                                                                                 // 1483
    roleAssignment: roleAssignment,                                                                                   // 1484
    petname: petname,                                                                                                 // 1485
    created: new Date(),                                                                                              // 1486
    expires: null                                                                                                     // 1487
  };                                                                                                                  // 1481
                                                                                                                      //
  var result = {};                                                                                                    // 1490
  var parentForSharing = false;                                                                                       // 1491
  if (provider.rawParentToken) {                                                                                      // 1492
    var parentToken = Crypto.createHash("sha256").update(provider.rawParentToken).digest("base64");                   // 1493
    var parentApiToken = db.collections.apiTokens.findOne({ _id: parentToken, grainId: grainId, objectId: { $exists: false } });
    if (!parentApiToken) {                                                                                            // 1496
      throw new Meteor.Error(403, "No such parent token found.");                                                     // 1497
    }                                                                                                                 // 1498
                                                                                                                      //
    if (parentApiToken.forSharing) {                                                                                  // 1500
      parentForSharing = true;                                                                                        // 1501
    }                                                                                                                 // 1502
                                                                                                                      //
    apiToken.identityId = parentApiToken.identityId;                                                                  // 1504
    apiToken.accountId = parentApiToken.accountId;                                                                    // 1505
                                                                                                                      //
    apiToken.parentToken = parentToken;                                                                               // 1507
    result.parentApiToken = parentApiToken;                                                                           // 1508
  } else if (provider.identityId) {                                                                                   // 1509
    apiToken.identityId = provider.identityId;                                                                        // 1510
    apiToken.accountId = provider.accountId;                                                                          // 1511
  }                                                                                                                   // 1512
                                                                                                                      //
  if (owner.webkey) {                                                                                                 // 1514
    // Non-null webkey is a special case not covered in ApiTokenOwner.                                                //
    // TODO(cleanup): Maybe ApiTokenOwner.webkey should be extended with these fields?                                //
    apiToken.owner = { webkey: null };                                                                                // 1517
    apiToken.forSharing = parentForSharing || owner.webkey.forSharing;                                                // 1518
    if (owner.webkey.expiresIfUnusedDuration) {                                                                       // 1519
      apiToken.expiresIfUnused = new Date(Date.now() + owner.webkey.expiresIfUnusedDuration);                         // 1520
    }                                                                                                                 // 1521
  } else if (owner.user) {                                                                                            // 1522
    var grainInfo = db.getDenormalizedGrainInfo(grainId);                                                             // 1523
    apiToken.owner = {                                                                                                // 1524
      user: {                                                                                                         // 1525
        identityId: owner.user.identityId,                                                                            // 1526
        title: owner.user.title,                                                                                      // 1527
        denormalizedGrainMetadata: grainInfo                                                                          // 1528
      }                                                                                                               // 1525
    };                                                                                                                // 1524
                                                                                                                      //
    if (grain.title !== owner.user.title) {                                                                           // 1532
      apiToken.owner.user.upstreamTitle = grain.title;                                                                // 1533
    }                                                                                                                 // 1534
  } else {                                                                                                            // 1535
    // Note: Also covers the case of `webkey: null`.                                                                  //
    apiToken.owner = owner;                                                                                           // 1537
  }                                                                                                                   // 1538
                                                                                                                      //
  if (unauthenticated) {                                                                                              // 1540
    var apiHost = {                                                                                                   // 1541
      _id: db.apiHostIdHashForToken(token),                                                                           // 1542
      hash2: Crypto.createHash("sha256").update(apiToken._id).digest("base64")                                        // 1543
    };                                                                                                                // 1541
    if (unauthenticated.options) {                                                                                    // 1545
      apiHost.options = unauthenticated.options;                                                                      // 1546
    }                                                                                                                 // 1547
                                                                                                                      //
    if (unauthenticated.resources) {                                                                                  // 1549
      // Mongo requires keys in objects to be escaped. Ugh.                                                           //
      apiHost.resources = {};                                                                                         // 1551
      for (var key in unauthenticated.resources) {                                                                    // 1552
        apiHost.resources[SandstormDb.escapeMongoKey(key)] = unauthenticated.resources[key];                          // 1553
      }                                                                                                               // 1554
    }                                                                                                                 // 1555
                                                                                                                      //
    db.collections.apiHosts.insert(apiHost);                                                                          // 1557
    apiToken.hasApiHost = true;                                                                                       // 1558
  }                                                                                                                   // 1559
                                                                                                                      //
  db.collections.apiTokens.insert(apiToken);                                                                          // 1561
                                                                                                                      //
  result.id = apiToken._id;                                                                                           // 1563
  result.token = token;                                                                                               // 1564
  return result;                                                                                                      // 1565
};                                                                                                                    // 1566
                                                                                                                      //
// Make self-destructing tokens actually self-destruct, so they don't                                                 //
// clutter the token list view.                                                                                       //
SandstormPermissions.cleanupSelfDestructing = function (db) {                                                         // 1570
  return function () {                                                                                                // 1571
    var now = new Date();                                                                                             // 1572
    db.removeApiTokens({ expiresIfUnused: { $lt: now } });                                                            // 1573
  };                                                                                                                  // 1574
};                                                                                                                    // 1575
                                                                                                                      //
SandstormPermissions.cleanupClientPowerboxRequests = function (db) {                                                  // 1577
  return function () {                                                                                                // 1578
    var tenMinutesAgo = new Date(Date.now() - 1000 * 60 * 10);                                                        // 1579
    db.removeApiTokens({                                                                                              // 1580
      "owner.clientPowerboxRequest": { $exists: true },                                                               // 1581
      created: { $lt: tenMinutesAgo }                                                                                 // 1582
    });                                                                                                               // 1580
  };                                                                                                                  // 1584
};                                                                                                                    // 1585
                                                                                                                      //
Meteor.methods({                                                                                                      // 1587
  transitiveShares: function transitiveShares(identityId, grainId) {                                                  // 1588
    check(identityId, String);                                                                                        // 1589
    check(grainId, String);                                                                                           // 1590
    if (this.userId) {                                                                                                // 1591
      var db = this.connection.sandstormDb;                                                                           // 1592
      return SandstormPermissions.downstreamTokens(db, { grain: { _id: grainId, identityId: identityId } });          // 1593
    }                                                                                                                 // 1595
  },                                                                                                                  // 1596
                                                                                                                      //
  newApiToken: function newApiToken(provider, grainId, petname, roleAssignment, owner, unauthenticated) {             // 1598
    check(provider, Match.OneOf({ identityId: String }, { rawParentToken: String }));                                 // 1599
    if (!owner.user && !owner.webkey) {                                                                               // 1600
      throw new Meteor.Error(403, "'webkey' and 'user' are the only allowed owners in newApiToken()");                // 1601
    }                                                                                                                 // 1603
                                                                                                                      //
    // other check()s happen in SandstormPermissions.createNewApiToken().                                             //
    var db = this.connection.sandstormDb;                                                                             // 1606
    if (provider.identityId) {                                                                                        // 1607
      if (!this.userId || !db.userHasIdentity(this.userId, provider.identityId)) {                                    // 1608
        throw new Meteor.Error(403, "Not an identity of the current user: " + provider.identityId);                   // 1609
      }                                                                                                               // 1610
    }                                                                                                                 // 1611
                                                                                                                      //
    if (provider.identityId) {                                                                                        // 1613
      provider.accountId = this.userId;                                                                               // 1614
    }                                                                                                                 // 1615
                                                                                                                      //
    return SandstormPermissions.createNewApiToken(this.connection.sandstormDb, provider, grainId, petname, roleAssignment, owner, unauthenticated);
  },                                                                                                                  // 1620
                                                                                                                      //
  updateApiToken: function updateApiToken(token, newFields) {                                                         // 1622
    var db = this.connection.sandstormDb;                                                                             // 1623
                                                                                                                      //
    check(token, String);                                                                                             // 1625
    check(newFields, { petname: Match.Optional(String),                                                               // 1626
      roleAssignment: Match.Optional(db.roleAssignmentPattern),                                                       // 1627
      revoked: Match.Optional(Boolean) });                                                                            // 1628
                                                                                                                      //
    if (!this.userId) {                                                                                               // 1630
      throw new Meteor.Error(403, "Must be logged in to modify a token");                                             // 1631
    }                                                                                                                 // 1632
                                                                                                                      //
    var apiToken = db.collections.apiTokens.findOne(token);                                                           // 1634
    if (!apiToken) {                                                                                                  // 1635
      throw new Meteor.Error(404, "No such token found.");                                                            // 1636
    }                                                                                                                 // 1637
                                                                                                                      //
    if (db.userHasIdentity(this.userId, apiToken.identityId)) {                                                       // 1639
      var modifier = { $set: newFields };                                                                             // 1640
      db.collections.apiTokens.update(token, modifier);                                                               // 1641
    } else {                                                                                                          // 1642
      throw new Meteor.Error(403, "User not authorized to modify this token.");                                       // 1643
    }                                                                                                                 // 1644
  }                                                                                                                   // 1645
});                                                                                                                   // 1587
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-permissions/permissions.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-permissions'] = {}, {
  SandstormPermissions: SandstormPermissions
});

})();

//# sourceMappingURL=sandstorm-permissions.js.map
